{DivFix is a utility for reindexing partial DivX AVI movies
Copyright (C) 2000-2002  Csaba Budai

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA}

unit DivX;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, Menus, ExtCtrls, Buttons, DropSource, DropTarget,
  ComCtrls, OleCtnrs, ShellApi;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    MaskEdit1: TMaskEdit;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Open1: TMenuItem;
    Regenerate1: TMenuItem;
    Strip1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Memo1: TMemo;
    Window1: TMenuItem;
    Stayontop1: TMenuItem;
    DropFileTarget1: TDropFileTarget;
    ProgressBar1: TProgressBar;
    Check1: TMenuItem;
    Stop: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    MaskEdit2: TMaskEdit;
    SpeedButton2: TSpeedButton;
    SaveDialog1: TSaveDialog;
    Image1: TImage;
    SpeedButton3: TSpeedButton;
    MaskEdit3: TMaskEdit;
    OpenDialog2: TOpenDialog;
    CheckBox3: TCheckBox;
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure StayTop(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DropFileTarget1Drop(Sender: TObject; ShiftState: TShiftState;
      Point: TPoint; var Effect: Integer);
    procedure Button3Click(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure ShowWebPage(Sender: TObject);

  private
    { Private declarations }
  public
  	Input,Output				: File;
    Backup							:	File;
    Log									:	Text;
		i,j									:	Cardinal;
		Size,Position				:	Cardinal;
		StreamStart					:	Cardinal;
    StreamSize					:	Cardinal;
    Difference					:	Cardinal;
    Frame								:	Cardinal;
    LastInputPosition		:	Cardinal;
		LastIndexPosition		:	Cardinal;
    LastBackupPosition	:	Cardinal;
    Interleaved		  	  : Boolean;
    OnTop								:	Boolean;
    StopButton					:	Boolean;
    Logging							:	Boolean;
		Chunkname						:	String[8];
		Temp								: integer;
		FrameType						:	Byte;
		Buffer							:	Array [0..32800] Of Byte;
    Text								: String;
    Text2								:	String[2];
  end;

  Const
  	KeyFrame  :	Longint = 16;
    NormFrame	:	Longint = 0;
    Number		:	Set of char =['0'..'9'];

var
  Form1: TForm1;

implementation

uses About;

{$R *.DFM}

procedure DisableButtons;
begin
	Form1.SpeedButton1.Enabled:=False;
 	Form1.SpeedButton2.Enabled:=False;
 	Form1.SpeedButton3.Enabled:=False;
	Form1.MaskEdit1.Enabled:=False;
	Form1.MaskEdit2.Enabled:=False;
	Form1.MaskEdit3.Enabled:=False;
	Form1.Button1.Enabled:=False;
  Form1.Button2.Enabled:=False;
  Form1.Button3.Enabled:=False;
  Form1.CheckBox1.Enabled:=False;
  Form1.CheckBox2.Enabled:=False;
  Form1.CheckBox3.Enabled:=False;
end;

procedure EnableButtons;
begin
	Form1.SpeedButton1.Enabled:=True;
	Form1.MaskEdit1.Enabled:=True;
	If Form1.CheckBox1.Checked Then
  Begin
  	Form1.SpeedButton2.Enabled:=True;
	  Form1.MaskEdit2.Enabled:=True;
  End;
	If Form1.CheckBox3.Checked Then
  Begin
  	Form1.SpeedButton3.Enabled:=True;
	  Form1.MaskEdit3.Enabled:=True;
  End;
 	Form1.Button1.Enabled:=True;
  Form1.Button2.Enabled:=True;
  Form1.Button3.Enabled:=True;
  Form1.CheckBox1.Enabled:=True;
  If Form1.CheckBox1.Checked Then Form1.CheckBox2.Enabled:=True;
  Form1.CheckBox3.Enabled:=True;
end;

procedure WriteOut(Text : String);
begin
	If Form1.Logging Then Writeln(Form1.Log,Text)
  Else Form1.Memo1.Lines.Insert(0,Text);
end;

function CheckOtherIndex(Var Input : File) : Cardinal;
Var	Position,i	:	Cardinal;
		OldPosition	:	Cardinal;
    Buffer			:	Array [0..32800] of Byte;
    Idx					:	String[4];
    Temp				:	Integer;

begin
	OldPosition:=FilePos(Input);
  Position:=FileSize(Input);
  i:=32768;
  Idx:='    ';
  If Position>32768 Then
  Repeat
		Dec(Position,32764);
    Seek(Input,Position);
    BlockRead(Input,Buffer,32768,Temp);
    i:=Temp;
    Repeat
			Dec(i);
      Move(Buffer[i],Idx[1],4);
    Until (i<0) Or (Idx='idx1');
	Until (Position<32768) Or (Idx='idx1');
  If (Position<32768) And (Idx<>'idx1') Then
  Begin
  	i:=Position;
    Position:=0;
    Seek(Input,0);
    Repeat
			Dec(i);
      Move(Buffer[i],Idx[1],4);
    Until (i<0) Or (Idx='idx1');
  End;
  Seek(Input,OldPosition);
  If Idx='idx1' Then Result:=Position+i
  Else Result:=0;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
	If OpenDialog1.Execute Then MaskEdit1.Text:=OpenDialog1.FileName;
  If MaskEdit1.Text<>'' Then MaskEdit2.Text:=ExtractFilePath(MaskEdit1.Text)+
  'DivFix.'+ExtractFileName(MaskEdit1.Text);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
	If SaveDialog1.Execute Then MaskEdit2.Text:=SaveDialog1.FileName;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
	If OpenDialog2.Execute Then MaskEdit3.Text:=OpenDialog2.FileName;
end;



procedure TForm1.Button1Click(Sender: TObject);
Var k	:	Cardinal;

Label BError;
Label BStartRead;

begin
	Logging:=False;
	DisableButtons;
	If MaskEdit1.Text='' Then
  Begin
		WriteOut(' No file selected.');
    EnableButtons;
  	Exit;
  End;
	AssignFile(Input,MaskEdit1.Text);
	AssignFile(Output,'$TEMP.IDX');
  AssignFile(Log,MaskEdit3.Text);
	If CheckBox1.Checked Then
  Begin
	  {$I-}
  	FileMode:=0;
		Reset(Input,1);
  	FileMode:=2;
		{$I+}
  End
  Else
  Begin
	 	{$I-}
  	Reset(Input,1);
	  {$I+}
  End;
  If IOResult<>0 Then
	Begin
		WriteOut(' Can not open the file.');
		EnableButtons;
    Exit;
  End;
  Seek(Input,8);
  BlockRead(Input,ChunkName[1],8,Temp);
  ChunkName[0]:=#8;
  If ChunkName<>'AVI LIST' Then
  Begin
  	WriteOut(' This is not an AVI file.');
    CloseFile(Input);
    EnableButtons;
    Exit;
  End;
	{$I-}
	Rewrite(Output,1);
	{$I+}
	If IOResult<>0 Then
	Begin
		WriteOut(' Cannot create temporary index file.');
    CloseFile(Input);
    EnableButtons;
    Exit;
  End;
	If CheckBox3.Checked Then
  Begin
		{$I-}
		Reset(Log);
		{$I+}
		If IOResult<>0 Then
    Begin
			{$I-}
			Rewrite(Log);
			{$I+}
			If IOResult<>0 Then
  	  Begin
				WriteOut(' Cannot create log file.');
  	  	CloseFile(Input);
    	 	CloseFile(Output);
	    	EnableButtons;
	  	  Exit;
		  End
      Else
	    Begin
				CloseFile(Log);
   		  Append(Log);
	    End;
    End
   	Else
    Begin
			CloseFile(Log);
   	  Append(Log);
    End;
  End;
	If CheckBox1.Checked Then
  Begin
    AssignFile(Backup,MaskEdit2.Text);
		{$I-}
		Rewrite(Backup,1);
		{$I+}
		If IOResult<>0 Then
		Begin
			WriteOut(' Cannot create backup file.');
	    CloseFile(Input);
    	CloseFile(Output);
			If CheckBox3.Checked Then CloseFile(Log);
  	  Erase(Output);
  	  EnableButtons;
	    Exit;
	  End;
  End;
	If CheckBox3.Checked Then
  Begin
  	Logging:=True;
		WriteOut(' Index rebuilding for file: '+MaskEdit1.Text);
  End
  Else WriteOut(' Rebuilding index...');
 	Position:=16;
  Size:=0;
 	Chunkname[0]:=#4;
  Repeat
 		Position:=Position+Size;
  	Seek(Input,Position);
    BlockRead(Input,Size,4);
 	  BlockRead(Input,Chunkname[1],4);
   	Inc(Position,8);
  Until Chunkname='movi';
 	StreamStart:=Position-4;
  StreamSize:=Size;
 	Chunkname:='idx1';
  BlockWrite(Output,Chunkname[1],4);
 	BlockWrite(Output,Size,4);
 	LastIndexPosition:=FilePos(Output);
  Position:=4;
 	i:=0;
  Frame:=0;
  Difference:=0;
  Interleaved:=False;
  StopButton:=False;
  Seek(Input,0);
  If CheckBox1.Checked Then
  Begin
	 	For k:=1 To (StreamStart+4) Div 32768 Do
		Begin
			BlockRead(Input,Buffer,32768,Temp);
			BlockWrite(Backup,Buffer,Temp);
		End;
		BlockRead(Input,Buffer,((StreamStart+4) Mod 32768),Temp);
		BlockWrite(Backup,Buffer,Temp);
  End;
  Repeat
    ProgressBar1.Position:=Position Div ((FileSize(Input)-StreamStart) Div 100);
 		Seek(Input,StreamStart+Position);
   	If Not Eof(Input) Then
    Begin
			BStartRead:
		  BlockRead(Input,Chunkname[1],4,Temp);
      If ChunkName='LIST' Then
      Begin
      	Seek(Input,FilePos(Input)+8);
        Inc(Position,12);
        Goto BStartRead;
			End;
      If ChunkName='JUNK' Then
      Begin
      	BlockRead(Input,Size,4);
        Position:=Position+Size+8;
      	Seek(Input,StreamStart+Position);
				Goto BStartRead;
			End;
      Text2:=Copy(ChunkName,3,2);
      If (Copy(ChunkName,1,2)='ix') Or (Text2='ix') Then
      Begin
        Inc(Position,16);
      	Seek(Input,StreamStart+Position);
        Interleaved:=True;
        Goto BStartRead;
			End;
      If Not Eof(Input) Then
      Begin
      	If ((ChunkName[1] In Number) And (ChunkName[2] In Number)) And
           ((Text2='dc') Or (Text2='db') Or (Text2='wb')) Then
        Begin
        	If (Text2='dc') Or (Text2='db') Then Inc(Frame);
          If Interleaved Then
          Begin
          	Seek(Input,FilePos(Input)-16);
            Dec(Position,16);
            Interleaved:=False;
          End;
				  BlockRead(Input,Size,4,Temp);
          If (Size<0) And (Temp=4) Then
          Begin
          	Inc(Position,4);
            Seek(Input,StreamStart+Position);
            BlockRead(Input,Chunkname[1],4,Temp);
            If ChunkName='LIST' Then
			      Begin
      				Seek(Input,FilePos(Input)+8);
              Inc(Position,12);
							Goto BStartRead;
						End;
            If ChunkName='JUNK' Then
			      Begin
      				BlockRead(Input,Size,4);
			        Position:=Position+Size+8;
			      	Seek(Input,StreamStart+Position);
			        Goto BStartRead;
						End;
            Seek(Input,StreamStart+Position);
            Goto BError;
					End;
		      If Not Eof(Input) Then
  		    Begin
          	LastInputPosition:=Filepos(Input)-4;
	  				BlockRead(Input,FrameType,1);
		    	  j:=(((Position+Size) Div 2)+((Position+Size) Mod 2))*2+8;
 	  		  	Seek(Input,StreamStart+j-1);
			   	  If Not Eof(Input) Then
  	  		  Begin
            	LastIndexPosition:=FilePos(Output);
						  BlockWrite(Output,Chunkname[1],4);
              Text2:=Copy(ChunkName,3,2);
						  If ((Text2='dc') Or (Text2='db') Or (Text2='wb')) And
              	 ((Chunkname[1]In Number) And (ChunkName[2] In Number)) And
                 (FrameType And 64=0)
              Then
              	BlockWrite(Output,KeyFrame,4)
  						Else
              	BlockWrite(Output,NormFrame,4);
			  			If CheckBox2.Checked Then
              Begin
              	j:=Position-Difference;
              	BlockWrite(Output,j,4)
              End
              Else BlockWrite(Output,Position,4);
					  	BlockWrite(Output,Size,4);
              j:=Position;
	 		  			Position:=(((Position+Size) Div 2)+((Position+Size) Mod 2))*2+8;
              Seek(Input,StreamStart+j);
              If CheckBox1.Checked Then
              Begin
              	LastBackupPosition:=FilePos(Backup);
	              If Position-j>32768 Then
  	            Begin
    	          	For k:=1 To (Position-j) Div 32768 Do
      	          Begin
										BlockRead(Input,Buffer,32768,Temp);
	  	    	        BlockWrite(Backup,Buffer,Temp);
	          	    End;
              	  BlockRead(Input,Buffer,((Position-j) Mod 32768),Temp);
	 	            	BlockWrite(Backup,Buffer,Temp);
  	            End
    	          Else
      	        Begin
	      	        BlockRead(Input,Buffer,Position-j,Temp);
  	      	      BlockWrite(Backup,Buffer,Temp);
            	  End;
              End;
			  		  Inc(i);
    			 	End;
   				End;
        End
        Else
        Begin
        	BError:
          If Chunkname<>'idx1' Then
          Begin
          	Str(Frame,Text);
	        	Text:=' Corrupted data detected at frame '+Text;
  	        If FilePos(Output)>16 Then Seek(Output,FilePos(Output)-16);
						WriteOut(Text);
            Str(StreamStart+Position,Text);
            Text:=' Error offset: '+Text+' ($'+IntToHex(StreamStart+Position,8)+')';
            WriteOut(Text);
            Seek(Output,LastIndexPosition);
            If CheckBox1.Checked Then Seek(Backup,LastBackupPosition);
            j:=Position;
      	    Repeat
        	  	Seek(Input,StreamStart+Position);
          	  If Not Eof(Input) Then
            	Begin
	      	  		BlockRead(Input,Buffer[1],32768,Temp);
                k:=1;
	              Repeat
		        	  	If ((Chr(Buffer[k])='d') Or (Chr(Buffer[k])='w')) Then
	  	        	  Begin
 		  		        	If ((Chr(Buffer[k+1])='c') Or (Chr(Buffer[k+1])='b')) Then
     	  	          Begin
      	  	        	Seek(Input,StreamStart+Position+k-3);
 	      	  	        If Not Eof(Input) Then BlockRead(Input,ChunkName[1],4);
   	      	  	    End;
     	      	  	End;
		  	          Inc(k);
                  Text2:=Copy(ChunkName,3,2);
								Until (((Text2='dc') Or (Text2='db') Or (Text2='wb')) And
                		  ((ChunkName[1] In Number) And (ChunkName[2] In Number))) Or
                      (Chunkname='idx1') Or (k>32768);
                Inc(Position,k-3);
	  	        End;
						  Application.ProcessMessages;
						  If StopButton Then
						  Begin
						  	WriteOut(' Index rebuilding aborted...');
						    ProgressBar1.Position:=0;
					  	  StopButton:=False;
								CloseFile(Input);
								CloseFile(Output);
                If CheckBox1.Checked Then CloseFile(Backup);
                If CheckBox3.Checked Then CloseFile(Log);
							 	Erase(Output);
                EnableButtons;
						   	Exit;
						  End;
              Text2:=Copy(ChunkName,3,2);
    	      Until (((Text2='dc') Or (Text2='db') Or (Text2='wb')) And
            		  ((ChunkName[1] In Number) And (ChunkName[2] In Number))) Or
                  (Chunkname='idx1') Or Eof(Input);
         		If Not Eof(Input) Then Dec(Position);
						If CheckBox1.Checked Then
            Begin
            	If Not(CheckBox2.Checked) Then
              Begin
	            	Seek(Input,StreamStart+j);
  		          If Position-j>32768 Then
	  	          Begin
      	        	For k:=1 To (Position-j) Div 32768 Do
     	  	        Begin
										BlockRead(Input,Buffer,32768,Temp);
	      	  	      BlockWrite(Backup,Buffer,Temp);
	         	  	  End;
             	  	BlockRead(Input,Buffer,((Position-j) Mod 32768),Temp);
		 	           	BlockWrite(Backup,Buffer,Temp);
  	            End
    		        Else
      		      Begin
	    	  	      BlockRead(Input,Buffer,Position-j,Temp);
  	      		    BlockWrite(Backup,Buffer,Temp);
          	  	End;
              End
              Else Difference:=Difference+LastInputPosition-FilePos(Input);
            End;
          End
          Else
          Begin
          	Seek(Input,FilePos(Input)+6);
            ChunkName[0]:=#2;
            BlockRead(Input,ChunkName[1],2);
            Seek(Input,FilePos(Input)-8);
            If (ChunkName='dc') Or (ChunkName='wb') Or (ChunkName='db') Then
            Begin
            	ChunkName[0]:=#4;
              ChunkName:='idx1';
            End
            Else
            Begin
            	ChunkName[0]:=#4;
              ChunkName:='0000';
              Goto BError;
            End;
          End;
       	End;
      End;
    End;
    Application.ProcessMessages;
    If StopButton Then
    Begin
    	WriteOut(' Index rebuilding aborted...');
      ProgressBar1.Position:=0;
      StopButton:=False;
		  CloseFile(Input);
		 	CloseFile(Output);
      If CheckBox1.Checked Then CloseFile(Backup);
      If CheckBox3.Checked Then CloseFile(Log);
		  Erase(Output);
      EnableButtons;
    	Exit;
    End;
	Until (Eof(Input)) Or (ChunkName='idx1');
 	Size:=i*16;
  Seek(Output,4);
 	BlockWrite(Output,Size,4);
	If CheckBox1.Checked Then
  Begin
  	If ChunkName='idx1' Then StreamSize:=FilePos(Backup)-StreamStart-4
    Else StreamSize:=Filesize(Backup)-StreamStart;
	  Seek(Backup,StreamStart-4);
 		BlockWrite(Backup,StreamSize,4);
	  Seek(Backup,StreamStart+StreamSize);
 		Seek(Output,0);
	  Repeat
 			BlockRead(Output,Buffer,32768,Temp);
   		BlockWrite(Backup,Buffer,Temp);
		Until Not(Temp=32768);
		WriteOut(' Done.');
	  If CheckBox3.Checked Then WriteOut('');
    ProgressBar1.Position:=100;
  	Truncate(Backup);
	  CloseFile(Input);
 		CloseFile(Output);
    CloseFile(Backup);
		If CheckBox3.Checked Then CloseFile(Log);
	  Erase(Output);
  End
  Else
  Begin
  	If ChunkName='idx1' Then StreamSize:=FilePos(Input)-StreamStart-4
    Else StreamSize:=Filesize(Input)-StreamStart;
	  Seek(Input,StreamStart-4);
 		BlockWrite(Input,StreamSize,4);
	  Seek(Input,StreamStart+StreamSize);
 		Seek(Output,0);
	  Repeat
 			BlockRead(Output,Buffer,32768,Temp);
   		BlockWrite(Input,Buffer,Temp);
		Until Not(Temp=32768);
  	Truncate(Input);
		WriteOut(' Done.');
	  If CheckBox3.Checked Then WriteOut('');
    ProgressBar1.Position:=100;
	  CloseFile(Input);
 		CloseFile(Output);
		If CheckBox3.Checked Then CloseFile(Log);
	  Erase(Output);
  End;
  EnableButtons;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
	DisableButtons;
  If Maskedit1.Text='' Then
  Begin
		WriteOut(' No file selected.');
    EnableButtons;
  	Exit;
  End;
	AssignFile(Input,MaskEdit1.Text);
  {$I-}
	Reset(Input,1);
	{$I+}
  If IOResult<>0 Then
	Begin
		WriteOut(' Can not open the file.');
    EnableButtons;
    Exit;
  End;
  Seek(Input,8);
  BlockRead(Input,ChunkName[1],8);
  ChunkName[0]:=#8;
  If ChunkName<>'AVI LIST' Then
  Begin
		WriteOut(' This is not an AVI file.');
    CloseFile(Input);
    EnableButtons;
    Exit;
  End;
  WriteOut(' Stripping index...');
 	Position:=16;
  Size:=0;
 	Chunkname[0]:=#4;
  Repeat
 		Position:=Position+Size;
  	Seek(Input,Position);
    BlockRead(Input,Size,4);
 	  BlockRead(Input,Chunkname[1],4);
   	Inc(Position,8);
  Until Chunkname='movi';
 	StreamStart:=Position-4;
  StreamSize:=Size;
  Seek(Input,StreamStart+StreamSize);
  If Eof(Input) Then
  Begin
  	WriteOut(' Unexpected end of file, index not found.');
    CloseFile(Input);
    EnableButtons;
    Exit;
  End;
	Truncate(Input);
  Seek(Input,StreamStart-4);
	BlockWrite(Input,StreamSize,4);
  CloseFile(Input);
	WriteOut(' Done.');
	EnableButtons;
end;

procedure TForm1.Button3Click(Sender: TObject);
Label CError;
Label CStartRead;

begin
	DisableButtons;
	If MaskEdit1.Text='' Then
  Begin
		WriteOut(' No file selected.');
    EnableButtons;
  	Exit;
  End;
	AssignFile(Input,MaskEdit1.Text);
  AssignFile(Log,MaskEdit3.Text);
  {$I-}
  FileMode:=0;
	Reset(Input,1);
  FileMode:=2;
	{$I+}
  If IOResult<>0 Then
	Begin
  	WriteOut(' Can not open the file.');
    EnableButtons;
    Exit;
  End;
	If CheckBox3.Checked Then
  Begin
		{$I-}
		Reset(Log);
		{$I+}
		If IOResult<>0 Then
    Begin
			{$I-}
			Rewrite(Log);
			{$I+}
			If IOResult<>0 Then
  	  Begin
				WriteOut(' Cannot create log file.');
  	  	CloseFile(Input);
	    	EnableButtons;
	  	  Exit;
		  End
      Else
	    Begin
				CloseFile(Log);
   		  Append(Log);
	    End;
    End
   	Else
    Begin
			CloseFile(Log);
   	  Append(Log);
    End;
  End;
  Seek(Input,8);
  BlockRead(Input,ChunkName[1],8);
  ChunkName[0]:=#8;
  If ChunkName<>'AVI LIST' Then
  Begin
  	WriteOut(' This is not an AVI file.');
    CloseFile(Input);
		If CheckBox3.Checked Then CloseFile(Log);
    EnableButtons;
    Exit;
  End;
	If CheckBox3.Checked Then
  Begin
  	Logging:=True;
		WriteOut(' Error checking for file: '+MaskEdit1.Text);
  End
  Else WriteOut(' Checking Errors...');
  WriteOut(' NOTE: The error checking is not perfect!');
 	Position:=16;
  Size:=0;
 	Chunkname[0]:=#4;
  Repeat
 		Position:=Position+Size;
  	Seek(Input,Position);
    BlockRead(Input,Size,4);
 	  BlockRead(Input,Chunkname[1],4);
   	Inc(Position,8);
  Until Chunkname='movi';
 	StreamStart:=Position-4;
  StreamSize:=Size;
 	Chunkname:='idx1';
  Position:=4;
 	i:=0;
  Frame:=0;
  Interleaved:=False;
  StopButton:=False;
  Repeat
    ProgressBar1.Position:=Position Div (FileSize(Input) Div 100);
 		Seek(Input,StreamStart+Position);
   	If Not Eof(Input) Then
    Begin
    	CStartRead:
		  BlockRead(Input,Chunkname[1],4,Temp);
      If ChunkName='LIST' Then
      Begin
      	Seek(Input,FilePos(Input)+8);
        Inc(Position,12);
        Goto CStartRead;
			End;
      If ChunkName='JUNK' Then
      Begin
      	BlockRead(Input,Size,4);
        Position:=Position+Size+8;
      	Seek(Input,StreamStart+Position);
        Goto CStartRead;
			End;
      Text2:=Copy(ChunkName,3,2);
      If (Copy(ChunkName,1,2)='ix') Or (Text2='ix') Then
      Begin
      	Seek(Input,FilePos(Input)+12);
        Inc(Position,16);
      	Seek(Input,StreamStart+Position);
        Interleaved:=True;
        Goto CStartRead;
			End;
      If Not Eof(Input) Then
      Begin
      	If ((ChunkName[1] In Number) And (ChunkName[2] In Number)) And
           ((Text2='dc') Or (Text2='db') Or (Text2='wb')) Then
        Begin
        	If (Text2='dc') Or (Text2='db') Then Inc(Frame);
          If Interleaved Then
          Begin
          	Seek(Input,FilePos(Input)-16);
            Dec(Position,16);
            Interleaved:=False;
          End;
				  BlockRead(Input,Size,4,Temp);
          If (Size<0) And (Temp=4) Then
          Begin
          	Inc(Position,4);
            Seek(Input,StreamStart+Position);
            BlockRead(Input,Chunkname[1],4);
      			If ChunkName='LIST' Then
			      Begin
			      	Seek(Input,FilePos(Input)+8);
              Inc(Position,12);
      			  Goto CStartRead;
						End;
            If ChunkName='JUNK' Then
			      Begin
      				BlockRead(Input,Size,4);
			        Position:=Position+Size+8;
			      	Seek(Input,StreamStart+Position);
      			  Goto CStartRead;
						End;
            Seek(Input,StreamStart+Position);
            Goto CError;
          End;
		      If Not Eof(Input) Then
  		    Begin
	  				BlockRead(Input,FrameType,1);
		    	  j:=(((Position+Size) Div 2)+((Position+Size) Mod 2))*2+8;
 	  		  	Seek(Input,StreamStart+j-1);
			   	  If Not Eof(Input) Then
  	  		  Begin
	 		  			Position:=(((Position+Size) Div 2)+((Position+Size) Mod 2))*2+8;
			  		  Inc(i);
    			 	End;
   				End;
        End
        Else
					CError:
          If Chunkname<>'idx1' Then
          Begin
          	Str(Frame,Text);
	        	Text:=' Corrupted data detected at frame '+Text;
						WriteOut(Text);
            Str(StreamStart+Position,Text);
            Text:=' Error offset: '+Text+' ($'+IntToHex(StreamStart+Position,8)+')';
            WriteOut(Text);
      	    Repeat
        	  	Seek(Input,StreamStart+Position);
          	  If Not Eof(Input) Then
            	Begin
	      	  		BlockRead(Input,Buffer[1],32768,Temp);
                j:=1;
	              Repeat
		        	  	If ((Chr(Buffer[j])='d') Or (Chr(Buffer[j])='w')) And (Not Eof(Input)) Then
	  	        	  Begin
		  		        	If ((Chr(Buffer[j+1])='c') Or (Chr(Buffer[j+1])='b')) And (Not Eof(Input)) Then
     	  	          Begin
      	  	        	Seek(Input,StreamStart+Position+j-3);
 	      	  	        If Not Eof(Input) Then BlockRead(Input,ChunkName[1],4);
   	      	  	    End;
     	      	  	End;
		  	          Inc(j);
                  Text2:=Copy(ChunkName,3,2);
								Until (((Text2='dc') Or (Text2='db') Or
		                  (Text2='wb')) And ((ChunkName[1] In Number) And
    		              (ChunkName[2] In Number))) Or (Chunkname='idx1') Or (j>32768);
	  	        End;
              Inc(Position,j-3);
              Application.ProcessMessages;
					    If StopButton Then
					    Begin
					    	WriteOut(' Error checking aborted...');
					      ProgressBar1.Position:=0;
					      StopButton:=False;
                CloseFile(Input);
								If CheckBox3.Checked Then CloseFile(Log);
                EnableButtons;
					    	Exit;
					    End;
              Text2:=Copy(ChunkName,3,2);
    	      Until (((Text2='dc') Or (Text2='db') Or
                  (Text2='wb')) And ((ChunkName[1] In Number) And
                  (ChunkName[2] In Number))) Or (Chunkname='idx1') Or Eof(Input);
          	If Not Eof(Input) Then Dec(Position);
        	End
          Else
          Begin
          	Seek(Input,FilePos(Input)+6);
            ChunkName[0]:=#2;
            BlockRead(Input,ChunkName[1],2);
            Seek(Input,FilePos(Input)-8);
            If (ChunkName='dc') Or (ChunkName='wb') Or (ChunkName='db') Then
            Begin
            	ChunkName[0]:=#4;
              ChunkName:='idx1';
            End
            Else
            Begin
            	ChunkName[0]:=#4;
              ChunkName:='0000';
              Goto CError;
            End
          End;
      End;
    End;
    Application.ProcessMessages;
    If StopButton Then
    Begin
    	WriteOut(' Error checking aborted...');
      ProgressBar1.Position:=0;
      StopButton:=False;
      CloseFile(Input);
			If CheckBox3.Checked Then CloseFile(Log);      
    	Exit;
    End;
	Until (Eof(Input)) Or (ChunkName='idx1');
	WriteOut(' Done.');
  If CheckBox3.Checked Then WriteOut('');
  ProgressBar1.Position:=100;
  CloseFile(Input);
	If CheckBox3.Checked Then CloseFile(Log);
	EnableButtons;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
	Close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
	Form2.Show;
end;

procedure TForm1.StayTop(Sender: TObject);
begin
	If Stayontop1.Checked Then
  Begin
  	Stayontop1.Checked:=Not(Stayontop1.Checked);
    SetWindowPos(TForm1(Self).Handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE+SWP_NOMOVE);
  End
  Else
  Begin
  	Stayontop1.Checked:=Not(Stayontop1.Checked);
    SetWindowPos(TForm1(Self).Handle,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE+SWP_NOMOVE);
  End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	DropFileTarget1.register(Form1)
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
	DropFiletarget1.Unregister;
end;

procedure TForm1.DropFileTarget1Drop(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
begin
	MaskEdit1.Text:=DropFileTarget1.files[0];
  If MaskEdit1.Text<>'' Then MaskEdit2.Text:=ExtractFilePath(MaskEdit1.Text)+
  'DivFix.'+ExtractFileName(MaskEdit1.Text);
end;

procedure TForm1.StopClick(Sender: TObject);
begin
	StopButton:=True;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  CheckBox2.Enabled:=Not(CheckBox2.Enabled);
  SpeedButton2.Enabled:=Not(SpeedButton2.Enabled);
  Maskedit2.Enabled:=Not(MaskEdit2.Enabled);
  If Not(CheckBox2.Enabled) Then CheckBox2.Checked:=False;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  SpeedButton3.Enabled:=Not(SpeedButton3.Enabled);
  Maskedit3.Enabled:=Not(MaskEdit3.Enabled);
  If Not(CheckBox2.Enabled) Then CheckBox2.Checked:=False;
end;

procedure TForm1.ShowWebPage(Sender: TObject);
begin
	ShellExecute(0,'open',pchar('http://divfix.maxeline.com'),nil,nil,SW_MAXIMIZE);
end;

end.
